<?php
/*
Concept, template, and code copyright 2007 Brian Enigma <brian@netninja.com>
Details @ http://netninja.com/2007/07/03/iphone-first-impressions/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

This file is part of Brian's iPhone Bookmark Template.

Brian's iPhone Bookmark Template is free software; you can redistribute it 
and/or modify it under the terms of the GNU General Public License as published 
by the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
Brian's iPhone Bookmark Template is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Brian's iPhone Bookmark Template; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/
class Link {
	var $title;
	var $icon;
	var $url;
	function Link() {
		$this->title = "";
		$this->icon = "";
		$this->url = "";
	}
	function set($title, $icon, $url) {
		$this->title = $title;
		$this->icon = $icon;
		$this->url = $url;
	}
	function importLine($s) {
		$a = explode("|", $s, 3);
		if (sizeof($a) != 3)
			die("Unable to parse line \"" . $s . "\" into 3 parts");
		$this->title = trim($a[0]);
		$this->icon = trim($a[1]);
		$this->url = trim($a[2]);
	}
	function exportLine() {
		return str_pad($this->title, 19) . "|" . str_pad($this->icon, 16) . "|" . $this->url;
	}
}
class LinkList {
	var $links = array();
	function load($filename) {
		$lines = file($filename);
		reset($lines);
		while (list($index, $line) = each($lines)) {
			if (strlen($line) > 0) {
				$link = new Link();
				$link->importLine($line);
				array_push($this->links, $link);
			}
		}
	}
	function save($filename) {
		// Write a temp file
		if (($f = fopen($filename . ".new", "w")) === FALSE)
			die("unable to open temp file \"" . $filename . ".new\" -- you probably need to set permissions");
		reset($this->links);
		while (list($index, $link) = each($this->links)) {
			fwrite($f, $link->exportLine() . "\n");
		}
		fclose($f);
		// Once successful, move it to the real file
		rename($filename . ".new", $filename);
	}
	function add($link) {
		array_push($this->links, $link);
	}
	function count() {
		return sizeof($this->links);
	}
	function item($i) {
		return $this->links[$i];
	}
	function remove($i) {
		array_splice($this->links, $i, 1);
	}
}
?>